package cn.org.bjca.trust.hm.demo.slice;

import cn.org.bjca.trust.hm.demo.ResourceTable;
import cn.org.bjca.trust.hm.demo.common.ToolsHelper;
import com.huawei.hms.push.common.ApiException;
import com.huawei.hms.push.ohos.HmsInstanceId;
import ohos.aafwk.ability.AbilitySlice;
import ohos.aafwk.content.Intent;
import ohos.agp.components.Text;
import ohos.hiviewdfx.HiLog;
import ohos.hiviewdfx.HiLogLabel;

public class PushAbilitySlice extends AbilitySlice {
    private static final HiLogLabel LABEL_LOG = new HiLogLabel(HiLog.LOG_APP, 0xD001234,
            "TokenAbilitySlice");

    private Text pushToken;

    @Override
    public void onStart(Intent intent) {
        super.onStart(intent);
        super.setUIContent(ResourceTable.Layout_ability_push);
        pushToken = (Text) findComponentById(ResourceTable.Id_push_token);
        getToken();
    }

    @Override
    protected void onStop() {
        super.onStop();
    }

    @Override
    public void onActive() {
        super.onActive();
    }

    @Override
    public void onForeground(Intent intent) {
        super.onForeground(intent);
    }

    private void getToken() {
        // 创建新线程
        new Thread("getToken") {
            @Override
            public void run() {
                try {
                    // 从agconnect-services.json文件中读取client_id
                    String appId = "your client_id";
                    // 输入token标识"HCM"
                    String tokenScope = "HCM";
                    // 获取Push Token
                    String token = HmsInstanceId.getInstance(getAbility().getAbilityPackage(), PushAbilitySlice.this).getToken(appId, tokenScope);
                    if (!ToolsHelper.isNull(token)) {
                        HiLog.info(LABEL_LOG, "onNewToken called, token:%{public}s", token);
//                        pushToken.setText(token);
                    }
                } catch (ApiException e) {
                    // 获取Push Token失败时，打印错误码
                    HiLog.error(LABEL_LOG, "get token failed, the error code is %{public}d", e.getStatusCode());
                }
            }
        }.start();
    }
}
