import { HuaweiIdAuthManager, HuaweiIdAuthParamsHelper } from '@hw-hmscore/hms-jsb-account';
import prompt from '@system.prompt';
import featureAbility from '@ohos.ability.featureAbility'

export default {
    data: {
        title: "",
        signInOption: null,
    },
    onInit() {
        this.title = "home";
        this.signInOption = new HuaweiIdAuthParamsHelper().setId().setProfile().setAuthorizationCode().build();

    },
    login() {
        if (!this.signInOption) {
            this.title = '初始化登录失败!'
        }
        // HuaweiIdAuthManager.getAuthApi方法返回huaweiIdAuth对象，在huaweiIdAuth对象中调用huaweiIdAuth.getSignInIntent方法
        HuaweiIdAuthManager.getAuthApi().getSignInIntent(this.signInOption).then((result) => {
            // 登录成功，获取用户的华为帐号信息
            console.info("signIn success");
            console.info(JSON.stringify(result));
            console.info("昵称: " + result.getDisplayName());
            console.info("头像: " + result.getAvatarUri());
            this.title = '登录成功!' + JSON.stringify(result)
        }).catch((error) => {
            // 登录失败
            console.error("signIn fail");
            console.error(JSON.stringify(error));
            this.title = '登录失败!' + JSON.stringify(error)
        });
    },
    login2() {
        if (!this.signInOption) {
            this.title = '初始化登录失败!'
        }
        // HuaweiIdAuthManager.getAuthApi方法返回huaweiIdAuth对象，在huaweiIdAuth对象中调用huaweiIdAuth.silentSignIn方法
        HuaweiIdAuthManager.getAuthApi().silentSignIn(this.signInOption).then((result) => {
            // 登录成功，获取用户的华为帐号信息
            console.info("silentSignIn success");
            console.info("昵称: " + result.getDisplayName());
            console.info("头像: " + result.getAvatarUri());
            console.info(JSON.stringify(result));
            this.title = '登录成功!' + JSON.stringify(result)
        }).catch((error) => {
            // 登录失败
            console.error("silentSignIn fail");
            console.error(JSON.stringify(error));
            this.title = '登录失败!' + JSON.stringify(error)
        });
    },
    logout() {
        // HuaweiIdAuthManager.getAuthApi方法返回huaweiIdAuth对象，在huaweiIdAuth对象中调用huaweiIdAuth.signOut方法
        HuaweiIdAuthManager.getAuthApi().signOut().then((result) => {
            //帐号退出成功
            console.info("signOut success");
            console.info(JSON.stringify(result));
            this.title = '帐号退出成功!' + JSON.stringify(result)
        }).catch((error) => {
            //帐号退出失败
            console.error("signout fail");
            console.error(JSON.stringify(error));
            this.title = '帐号退出失败!' + JSON.stringify(error)
        });
    },
    takePhoto(e) {
        var camera = this.$element('camera');
        console.info('-------------拍照------' + camera)
        var c = this;
        camera.takePhoto({
            quality: 'high',
            success(result) {
                c.title = result.uri;
                console.info('-------------拍照成功回调------' + result)
            },
            fail(result) {
                console.info('-------------拍照失败回调------' + result)
            },
            complete(result) {
                console.info('-------------拍照结束回调------' + result)
            }
        })
    },
    cameraError() {
        console.info('-------------拍照授权失败------')
        prompt.showToast({
            message: "授权摄像头失败！"
        });
    },
    selectedPhoto() {
        featureAbility.startAbility({
            want: {
                type: "image/*",
                action: "android.intent.action.GET_CONTENT"
            }
        }, res => {
            console.info('-------------选择图片回调------' + res)
        })
    },
}
